import { skillsById } from "./skills-addon-2.js"
import { ActionFormData } from "mojang-minecraft-ui"

function infoMessage(message) {
    return new ActionFormData()
        .title("§l[!]")
        .body(message)
        .button("Ok")
}

const alreadyOwned = infoMessage("You already have this upgrade!")
const success = infoMessage("Success!")

var menu = [new ActionFormData().title("Skills Table").body("Crouch + Interact with the Skills Table to view your skill points and XP."), []]

var s = 0
for (const skill of Object.values(skillsById)) {
    menu[0].button(`§l${skill.displayName}`)

    menu[1].push([new ActionFormData().title(`${skill.displayName}§r - Skills Table`), []])
    for (const upgrade of skill.upgrades) {
        menu[1][s][0].button(`${upgrade.displayName} (${upgrade.price}p)`)
        menu[1][s][1].push(upgrade)
    }

    s++
}

function menuRequiresTag(player, tagRequiredDisplayName) {
    infoMessage(`You need §l${tagRequiredDisplayName}§r to purchase this upgrade!`)
        .show(player)
}

function notEnoughPoints(player, skillDisplayName, pointsRequired) {
    infoMessage(`You do not have enough §l${skillDisplayName}§r skill points! You need ${pointsRequired}.`)
        .show(player)
}

function purchase(player, upgrade) {
    let tags = player.getTags()
    let upgradeGroupTags = upgrade.upgradeGroup.slice(upgrade.upgradeGroup.indexOf(upgrade.id))
    if (((upgrade.upgradeGroup.length == 0 && !player.hasTag(upgrade.id)) || (upgrade.upgradeGroup.length > 0 && !upgradeGroupTags.some(i => tags.includes(i))))) {
        let previousUpgradeId
        let prevIndex = upgrade.upgradeGroup.indexOf(upgrade.id) - 1
        if (prevIndex > -1) { previousUpgradeId = upgrade.upgradeGroup[prevIndex] }
        if (!previousUpgradeId || player.hasTag(previousUpgradeId)) {
            try { player.runCommand(`tag @s[scores={${upgrade.skillId}L=${upgrade.price}..}] add sa2:purchased`) } catch { }
            if (player.hasTag("sa2:purchased")) {
                player.removeTag("sa2:purchased")
                player.runCommand(`scoreboard players remove @s ${upgrade.skillId}L ${upgrade.price}`)
                player.addTag(upgrade.id)
                if (previousUpgradeId) { player.removeTag(previousUpgradeId) }
                success.show(player)
            } else {
                notEnoughPoints(player, skillsById[upgrade.skillId].displayName, upgrade.price)
            }
        } else {
            menuRequiresTag(player, skillsById[upgrade.skillId].upgradesById[previousUpgradeId].displayName)
        }
    } else {
        alreadyOwned.show(player)
    }
}

export function openSkillsMenu(player) {
    menu[0].show(player).then((response) => {
        let m = menu[1][response.selection]
        m[0].show(player).then((res) => {
            purchase(player, m[1][res.selection])
        })
    })
}